<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt'
import { useAuthStore } from '@/stores/auth'
import { usePromotionStore } from '@/stores/promotion'
import { useMembersStore } from '@/stores/member'
import type { ReceiptItem } from '@/types/ReceiptItem'
import { ref } from 'vue'
import jsPDF from 'jspdf'
import html2canvas from 'html2canvas'
import type auth from '@/services/auth'

const receiptStore = useReceiptStore()
const authStore = useAuthStore()
const promotionStore = usePromotionStore()
const memberStore = useMembersStore()
function size(item: ReceiptItem): string {
  if (item.gsize != '-') {
    return '(' + item.gsize + ')'
  }
  return ''
}

function type(item: ReceiptItem): string {
  if (item.type != '-') {
    return '(' + item.type + ')'
  }
  return ''
}

function sweetLv(item: ReceiptItem): string {
  if (item.sweet_level != '-') {
    return '(' + item.sweet_level + ')'
  }
  return ''
}
function closeDialog() {
  receiptStore.closeDialog()
  receiptStore.deletePoint()
  receiptStore.calReceipt()
}

function comfirmDialog() {
  receiptStore.receiptDialog = false
  memberStore.editedMember = memberStore.currentMember!
  receiptStore.addPoint()
  memberStore.saveMember()
  receiptStore.addReceipt()
  receiptStore.clear()
  memberStore.clear()
}

function savePDF() {
  const receipt = document.getElementById('receipt')
  html2canvas(receipt!).then((canvas) => {
    const imageData = canvas.toDataURL('image/png')
    const pdf = new jsPDF()
    pdf.addImage(imageData, 'PNG', 0, 0, 100, 200)
    pdf.save('receipt.pdf')
  })
}
</script>
<template>
  <v-dialog v-model="receiptStore.receiptDialog" persistent width="350" height="auto" scrollable>
    <v-card>
      <v-card-title>Receipt</v-card-title>
      <div id="receipt">
        <v-card-text justify="center" align="center" style="border: 1px solid">
          <v-img :width="100" aspect-ratio="1/1" src="./img/logo/logo.png"></v-img>
          <!-- head -->
          <v-container>
            <v-row justify="center">D-Coffee</v-row>

            <v-row justify="center" style="font-size: 10px" v-if="receiptStore.isEmp()"
              >สาขา {{ authStore.getCurrentUser()!.branch?.name }}</v-row
            >
            <v-row justify="center" style="font-size: 10px" v-else
              >สาขา {{ receiptStore.editedReceipt.branch?.name }}</v-row
            >

            <v-row justify="center" style="font-size: 10px" v-if="receiptStore.isEmp()"
              >{{ authStore.getCurrentUser()!.branch?.Address }}
              {{ authStore.getCurrentUser()!.branch?.tel }}</v-row
            >
            <v-row justify="center" style="font-size: 10px" v-else
              >{{ receiptStore.editedReceipt.branch?.Address }}
              {{ receiptStore.editedReceipt.branch?.tel }}</v-row
            >

            <br /><br />
            <v-row justify="center" style="font-size: 10px"
              >ใบเสร็จรับเงิน/ใบกำกับภาษีอย่างย่อ</v-row
            >
          </v-container>
          <v-divider></v-divider>
          <!-- เวลา และ user -->
          <v-container class="pa-0">
            <v-row no-gutters class="justify-start">
              <v-col>
                <div>
                  <p style="font-size: 10px; text-align: left">
                    Date: {{ receiptStore.textDate[0] }}
                  </p>
                  <p style="font-size: 10px; text-align: left" v-if="receiptStore.isEmp() && !receiptStore.editedReceipt.id">
                    Time: {{ receiptStore.textDate[1] }}
                  </p>
                </div>
              </v-col>
              <v-col
                ><p style="font-size: 10px; text-align: right" v-if="receiptStore.isEmp() && !receiptStore.editedReceipt.id">
                  User: {{ authStore.getCurrentUser()!.fullName }}
                </p>
                <p style="font-size: 10px; text-align: right" v-else>
                  Time: {{ receiptStore.textDate[1] }}
                </p></v-col
              >
            </v-row>
          </v-container>
          <v-divider></v-divider>
          <!-- ตาราง -->
          <v-container class="pa-0">
            <v-table density="compact">
              <thead>
                <tr style="font-size: 10px; text-align: left">
                  <th>Name</th>
                  <th>Unit</th>
                  <th>Price</th>
                  <th>Total</th>
                </tr>
              </thead>
              <tbody>
                <tr
                  v-for="item of receiptStore.receiptItems"
                  :key="item.id"
                  style="font-size: 10px; text-align: left"
                >
                  <td>{{ item.name + type(item) + size(item) + sweetLv(item) }}</td>
                  <td>{{ item.unit }}</td>
                  <td>{{ item.price }} ฿</td>
                  <td>{{ item.unit * item.price }} ฿</td>
                </tr>
              </tbody>
            </v-table>
          </v-container>
          <v-divider></v-divider>
          <!-- รายละเอียด -->
          <v-container class="pa-0" style="width: 300px">
            <v-row no-gutters>
              <v-divider></v-divider>
              <v-col cols="6" class="text-receipt"
                ><p v-if="receiptStore.isEmp()">
                  สมาชิก:
                  {{
                    receiptStore.editedReceipt.member ? receiptStore.editedReceipt.member.name : '-'
                  }}
                </p>
                <p v-else>
                  สมาชิก:
                  {{ authStore.getCurrentMember()?.name }}
                </p>
              </v-col>
              <v-col cols="3" class="text-receipt" v-if="!receiptStore.editedReceipt.id"
                ><p v-if="receiptStore.isEmp()">
                  แต้ม:
                  {{
                    receiptStore.editedReceipt.member
                      ? receiptStore.editedReceipt.member.point
                      : '-'
                  }}
                </p>
                <p v-else>
                  แต้ม:
                  {{ authStore.getCurrentMember()?.point }}
                </p>
              </v-col>
              <v-col cols="3" class="text-receipt"
                ><p>
                  ลดด้วยแต้ม:
                  {{
                    receiptStore.editedReceipt.member
                      ? receiptStore.editedReceipt.member_discount
                      : '-'
                  }}
                </p></v-col
              >
              <v-divider></v-divider>
              <v-col cols="12" class="text-receipt"
                ><p>
                  โปรโมชั่น:
                  {{
                    receiptStore.editedReceipt.promotions
                      ? receiptStore.editedReceipt.promotions
                          .map((promotion) => promotion.name)
                          .join(', ')
                      : '-'
                  }}
                  <!--แก้โปรโมชั่นด้วย -->
                </p></v-col
              >
              <v-col cols="12" class="text-receipt"
                ><p>
                  ส่วนลดโปรโมชั่น:
                  {{
                    receiptStore.editedReceipt.promotions
                      ? receiptStore.editedReceipt.promotion_discount + ' ฿'
                      : '-'
                  }}
                </p></v-col
              >
              <v-divider></v-divider>
              <v-col cols="6" class="text-receipt"
                ><p>ราคา: {{ receiptStore.editedReceipt.total_before }} ฿</p></v-col
              >
              <v-col cols="6" class="text-receipt"
                ><p>
                  ส่วนลด:
                  {{ receiptStore.editedReceipt.member_discount }} ฿
                </p></v-col
              >
              <v-col cols="6" class="text-receipt"
                ><p>ราคารวมทั้งสิ้น: {{ receiptStore.editedReceipt.total }} ฿</p></v-col
              >
              <v-col cols="6" class="text-receipt"
                ><p>วิธีการจ่าย: {{ receiptStore.editedReceipt.paymentType }}</p></v-col
              >
              <v-col col="6" class="text-receipt"
                ><p>จำนวน: {{ receiptStore.editedReceipt.qty }}</p></v-col
              >
              <v-col cols="6" class="text-receipt"
                ><p>เงิน: {{ receiptStore.editedReceipt.receivedAmount }} ฿</p></v-col
              >
              <v-col cols="6"></v-col>
              <v-col cols="6" class="text-receipt"
                ><p>เงินทอน: {{ receiptStore.editedReceipt.change }} ฿</p></v-col
              >
              <!-- {{ receiptStore.editedReceipt.userId }} -->
            </v-row>
          </v-container>
          <v-divider></v-divider>
          <p style="font-size: 11px; padding-top: 10px">ขอบคุณที่ใช้บริการค่ะ</p>
        </v-card-text>
      </div>
      <v-card-actions>
        <v-spacer> </v-spacer>
        <v-btn @click="receiptStore.changeComponent(1), closeDialog()">ยกเลิก</v-btn>
        <v-btn v-if="!receiptStore.editedReceipt.id" @click="comfirmDialog()">ยืนยัน</v-btn>
        <v-btn icon="mdi-printer" @click="savePDF()"></v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<style scoped>
tbody tr:nth-of-type(even) {
  background-color: white;
}

tbody tr:nth-of-type(odd) {
  background-color: white;
}

thead {
  background-color: white;
  color: rgb(0, 0, 0);
  font-weight: bold;
}
.theme--light.v-data-table thead tr th {
  color: white;
}

.text-receipt {
  font-size: 11px;
  text-align: left;
}
</style>
